--------------------------------------------------------------------------------------------
--|> FOCUS TARGET FRAME
----------------------------------------------------------------------------------------------------------
--> ⬆ Upvalues
local C_NamePlate_GetNamePlateForUnit = C_NamePlate.GetNamePlateForUnit
local UnitIsUnit = UnitIsUnit

--> Core Focus Target Frame
--------------------------------------
FTL_FOCUS_TARGET_FRAME = FTL_FOCUS_TARGET_FRAME or CreateFrame("Frame", "FTL_FOCUS_TARGET_FRAME", UIParent)
FTL_FOCUS_TARGET_FRAME:SetFrameStrata("HIGH")
FTL_FOCUS_TARGET_FRAME:SetPoint("CENTER", UIParent)
FTL_FOCUS_TARGET_FRAME:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME:SetIgnoreParentAlpha(true)
FTL_FOCUS_TARGET_FRAME:SetAlpha(0)
--: Icon
FTL_FOCUS_TARGET_FRAME.arrow = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "ARTWORK", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.arrow:SetTexture("interface/addons/FTL/Media/Textures/ftTexture.tga")
FTL_FOCUS_TARGET_FRAME.arrow:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")
FTL_FOCUS_TARGET_FRAME.arrow:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME.arrow:SetDrawLayer("OVERLAY", 1)
FTL_FOCUS_TARGET_FRAME.arrow:SetVertexColor(1, 0.49, 0, 1)
FTL_FOCUS_TARGET_FRAME.arrow:SetBlendMode("ADD")
--: Outline
FTL_FOCUS_TARGET_FRAME.outline = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.outline:SetTexture("interface/addons/FTL/Media/Textures/ftOutline.tga")
FTL_FOCUS_TARGET_FRAME.outline:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.outline:SetVertexColor(1, 1, 1, 0.8)
FTL_FOCUS_TARGET_FRAME.outline:SetDrawLayer("ARTWORK", 7)
FTL_FOCUS_TARGET_FRAME.outline:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")
--: Shadow
FTL_FOCUS_TARGET_FRAME.shadow = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.shadow:SetTexture("interface/addons/FTL/Media/Textures/ftShadow.tga")
FTL_FOCUS_TARGET_FRAME.shadow:SetVertexColor(0, 0, 0, 0.5)
FTL_FOCUS_TARGET_FRAME.shadow:SetDrawLayer("BACKGROUND")
FTL_FOCUS_TARGET_FRAME.shadow:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.shadow:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")

--> Hide
--------------------------------------
function FTL_FOCUS_TARGET_FRAME:Hide()
    self:SetAlpha(0)
    self:ClearAllPoints()
end

--> Show
--------------------------------------
function FTL_FOCUS_TARGET_FRAME:Show()
    if UnitIsUnit("focustarget", "focus") then
        self:Hide()
        return
    end
    if C_NamePlate_GetNamePlateForUnit("focustarget") then
        self:ClearAllPoints()
        self:SetPoint("BOTTOM", C_NamePlate_GetNamePlateForUnit("focustarget"), "CENTER", 0, 30)
        self:SetAlpha(1)
    else
        self:Hide()
    end
end

--> Show Assist
--------------------------------------
local function ShowAssist()
    FTL_FOCUS_TARGET_FRAME.arrow:SetVertexColor(1, 0, 0.2, FTL_FOCUS_TARGET_FRAME.arrow:GetAlpha())
    FTL_FOCUS_TARGET_FRAME:SetScale(1.25)
end

--> Hide Assist
--------------------------------------
local function HideAssist()
    FTL_FOCUS_TARGET_FRAME.arrow:SetVertexColor(1, 0.49, 0, FTL_FOCUS_TARGET_FRAME.arrow:GetAlpha())
    FTL_FOCUS_TARGET_FRAME:SetScale(1)
end

--> Check For Assist
--------------------------------------
function FTL_FOCUS_TARGET_FRAME:CheckForAssist()
    if UnitIsUnit("target", "focustarget") then
        ShowAssist()
    else
        HideAssist()
    end
    self:Show()
end
